SystemOrganization addCategory: #TOcurricula!

Object subclass: #Consultor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

!Consultor methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 11/9/2012 11:44'!
cargarDataFile: arc
	"En esta funcion vamos a abrir el file que contiene la informacion que se graficara
	y se devolver la matriz o array que contiene la informacion de los cursos"
	| arch col stream1 stream2 mat data cad |
	arch := FileStream fileNamed: arc.
	mat := OrderedCollection new.
	data := OrderedCollection new.
	stream1 := (arch contentsOfEntireFile) readStream .
	stream2 := (arch contentsOfEntireFile) readStream .
	[stream1 atEnd not & stream2 atEnd not] whileTrue: [
		stream1 skipTo: $%.	"encuentra el simbolo de separacion"
		cad := stream2 next: ((stream1 position - stream2 position )- 1).
		mat add: cad asString. 
		stream2 next. 	"avanza una posicion despues del simbolo de separacion para leer la nueva palabra"
		(stream2 peek = $#) ifTrue: [ stream2 next. data add: mat. mat := OrderedCollection new. ]
	].
	data removeFirst.
	^data.! !

!Consultor methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 12:19'!
cargarDataUrl: nomLink
	| data jsonObject subs tam |
	jsonObject := self conectarTo: nomLink.
	data := OrderedCollection new.
	subs :=	jsonObject at: 'feed'.
	subs := subs at: 'entry'.
	tam := subs size .
	1 to: tam do: [:pos | 
		| mat prereq | 
		mat := Curso new .
		prereq := OrderedCollection new.
		mat codigo: (((subs at: pos) at: 'gsx$codigo') at: '$t').
		mat nombre: (((subs at: pos) at: 'gsx$nombre') at: '$t').
		mat creditos: (((subs at: pos) at: 'gsx$cred') at: '$t').
		mat semestre: (((subs at: pos) at: 'gsx$semestre') at: '$t').
		prereq add: (((subs at: pos) at: 'gsx$prereq1') at: '$t').
		prereq add: (((subs at: pos) at: 'gsx$prereq2') at: '$t').
		prereq add: (((subs at: pos) at: 'gsx$prereq3') at: '$t').
		prereq add: (((subs at: pos) at: 'gsx$prereq4') at: '$t').
		mat hrsteo: (((subs at: pos) at: 'gsx$hrsteoria') at: '$t').
		mat hrsprac: (((subs at: pos) at: 'gsx$hrsprac') at: '$t').
		mat hrsteoprac: (((subs at: pos) at: 'gsx$hrsteoprac') at: '$t').
		mat hrstotal: (((subs at: pos) at: 'gsx$hrstotal') at: '$t').
		mat prereqs: prereq.
		data add: mat
	].
	^data! !

!Consultor methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 23:50'!
conectarTo: cad
	| dir parser jsonObject json |
	(cad ~= '') ifTrue: [dir := cad] 
		ifFalse: [dir := 'http://spreadsheets.google.com/feeds/list/0AjE_p7Re6WDHdEJKUEVIM0dLWlY1TjRPZnQ1ZnVyVGc/od6/public/values?alt=json'].		
	parser := PPParserResource current parserAt: PPJsonParser.
	json := (Url absoluteFromText: dir) retrieveContents contents.
	jsonObject := parser parse: json.
	^jsonObject 
! !

Object subclass: #Curso
	instanceVariableNames: 'codigo nombre creditos semestre hrstotal hrsprac hrsteo hrsteoprac prereqs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:13'!
codigo
	^codigo! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:09'!
codigo: cod
	codigo := cod! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:14'!
creditos
	^creditos ! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:11'!
creditos: cred
	creditos := cred! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:18'!
hrsprac 
	^hrsprac ! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:11'!
hrsprac: hrs
	hrsprac := hrs! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:18'!
hrsteo 
	^hrsteo ! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:11'!
hrsteo: hrs
	hrsteo := hrs! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:18'!
hrsteoprac 
	^hrsteoprac ! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:12'!
hrsteoprac: hrs
	hrsteoprac := hrs ! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:18'!
hrstotal
	^hrstotal ! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:10'!
hrstotal: hrs
	hrstotal := hrs! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 12:21'!
info
	| cad |
	cad  :=	'Codigo: ', self codigo , String cr,
			'Nombre: ', self nombre , String cr,
			'Creditos: ', self creditos , String cr,
			'Semestre: ', self semestre , String cr,
			'Hrs Teoria: ', self hrsteo , String cr,
			'Hrs Practica: ', self hrsteoprac , String cr,
			'Hrs TeoricoPracticas: ', self hrsteoprac , String cr,
			'Horas totales: ', self hrstotal.
	^cad! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:14'!
nombre
	^nombre! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:10'!
nombre: nom
	nombre := nom! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:21'!
prereqs
	^prereqs! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 11:37'!
prereqs: setReqs
	prereqs := OrderedCollection new.
	prereqs := setReqs! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 12:19'!
semestre
	^semestre! !

!Curso methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 12:19'!
semestre: sem
	semestre := sem! !

Object subclass: #IteradorMalla
	instanceVariableNames: 'posicion malla'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

!IteradorMalla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:48'!
hasNext
	( posicion <= (malla numCursos) ) ifTrue: [
		^true] 
	ifFalse: [
		^false]! !

!IteradorMalla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:49'!
init: mall
	malla := mall.
	posicion := 1! !

!IteradorMalla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 14:26'!
next
	| cur |
	cur := malla getCursoIn: posicion .
	posicion := posicion + 1.
	^cur ! !

Object subclass: #Malla
	instanceVariableNames: 'cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

!Malla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:34'!
add: cur
	cursos add: cur! !

!Malla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:57'!
buscar: codigo
	| i enc|
	i := 0.
	enc := 0.
	[enc = 0] whileTrue: [
		i := i + 1.
		((cursos at: i) codigo = codigo ) ifTrue: [enc := 1]
	].
	(i <= (cursos size)) ifTrue: [^i]! !

!Malla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:16'!
cursos
	^cursos! !

!Malla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:16'!
cursos: cur
	cursos := cur! !

!Malla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:20'!
getCurso: cod
	| pos |
	pos := self buscar: cod.
	^(cursos at: pos)! !

!Malla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 14:25'!
getCursoIn: pos
	^(cursos at: pos)! !

!Malla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:38'!
initialize 
	cursos := Consultor new cargarDataUrl: ''.		"Cargamos la matriz de los cursos que tenemos almacenados"! !

!Malla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:27'!
iterador
	^(IteradorMalla new init: self)! !

!Malla methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:23'!
numCursos
	^cursos size! !

Object subclass: #Visualizador
	instanceVariableNames: 'malla'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

!Visualizador methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/17/2012 13:52'!
mostrarFrom: nomSource
	| view it |
	view := MOViewRenderer new.
	"Aplicando patron ITERATOR"
	malla := Malla new.
	it := malla iterador.
	
	[it hasNext] whileTrue: [
		| cur cod req |
		"Este mensaje se mostrar cuando se pasa el Mouse sobre el cuadro"
		view interaction popupText: [:entity | 
			self mostrarInfo: (entity)
		].
		
		"Establecemos una accion de informacion cuando se haga clic en el nodo"
		view interaction on: MOMouseDouble do: [ :ann | 
			self inform: (self mostrarInfo: (ann model))
		].
		cur := it next.
		cod :=  cur codigo.
		view shape rectangle width: 50; withText; fontSize: 10.
		view node: cod.		
		view shape: (MOArrowedOrthoVerticalLineShape new).
		"Aqui analizamos los prerequisitos de cada uno de los cursos, para mostrar la relacion entre ambos"
		1 to: (cur prereqs) size do: [:j |
			req := (cur prereqs) at: j.
			(req = '' | req = ' ') ifFalse: [
				view edges: { req -> cod } from: #key to: #value ]
		].
	].
	view treeLayout.
	view open ! !

!Visualizador methodsFor: 'as yet unclassified' stamp: 'AngelaMayhua 11/18/2012 09:30'!
mostrarInfo: codigo
	| cur |
	cur := malla getCurso: codigo.
	^ (cur info)! !
